<template>
  <div class="card flex justify-content-center">
    <label for="mask" class="font-bold block mb-2">{{ dirTitle }}</label>
    <Tree :value="dirNodes" selectionMode="single" @node-select="onNodeDirSelect" class="w-full md:w-30rem"></Tree>
    <label for="mask" class="font-bold block mb-2">{{ fileTitle }}</label>
    <Tree :value="fileNodes" selectionMode="single" @node-select="onNodeFileSelect" class="w-full md:w-30rem"></Tree>
  </div>
</template>

<script setup lang="ts">
// Components
import { ref, watch, onMounted } from 'vue';
import Tree from 'primevue/tree';
// Adds js/ts
import * as treeview from '../core/treeview'
import { treeviewLang, getTextFromLang } from '../core/lang'
import type { TreeNode } from 'primevue/treenode';

// props
const props = defineProps(['dirPaths', 'dirPathsLength', 'filePaths', 'lang']);

// emits
const emit = defineEmits(['dir-path-selected', 'file-selected']);

const fileNodes = ref<TreeNode[]>();
const dirNodes = ref<TreeNode[]>();

// const dirTitle = ref(getTextFromLang(treeviewLang.dirTitle, props.lang))
// const fileTitle = ref(getTextFromLang(treeviewLang.fileTitle, props.lang))
const dirTitle = ref("");
const fileTitle = ref("");

//-- ONMOUNTED --
onMounted(() => {
  dirTitle.value = getTextFromLang(treeviewLang.dirTitle, props.lang);
  fileTitle.value = getTextFromLang(treeviewLang.fileTitle, props.lang);
})

//-- CALLBACKS --
/** Enviar información de archivo seleccionado del treeview */
const onNodeDirSelect = (node: any) => {
  console.log(node.data)
  emit('dir-path-selected', node.data);
}
/** Enviar información de directorio seleccionado del treeview */
const onNodeFileSelect = (node: any) => {
  console.log(node.data)
  // node.data -> path
  emit('file-selected', node.data);
}

//-- WATCHERS --
/** Observar cambios en rutas de directorios */
watch(() => props.dirPathsLength,
  () => {
    dirNodes.value = treeview.getDirItems(props.dirPaths);
  });

/** Observar cambios en rutas de archivos */
watch(() => props.filePaths,
  async (filePaths) => {
    fileNodes.value = treeview.getFileItems(filePaths);
  });

/*
onMounted(() => {
  nodes.value = initateNodes();
});

const initateNodes = () => {
  return [
      {
          key: '0',
          label: 'Node 0',
          leaf: true
      },
      {
          key: '1',
          label: 'Node 1',
          leaf: false
      },
      {
          key: '2',
          label: 'Node 2',
          leaf: false
      }
  ];
};
*/
</script>

<style scoped>
:deep(.p-tree) {
  padding: 0;
}
</style>
